# Everyware cache invalidator
__Current version: 0.1.3__

Everyware cache invalidator is a plugin that is dependent on Everyware and Everyboard, it invalidates the frontcache on an event basis.

## Implementation of lua endpoint
For this plugin to work, the server environment must have an endpoint that answers to "/ledge-invalidate", this endpoint should 
invalidate the url sent to it from the cache. If you are using Everyware in a Infomaker hosted environment we have included a 
`example.lua` file that should work out of the box. The following instructions are for a Infomaker hosted environment with nginx/lua support.

The function needs to be initiated in the ledge-run.lua file, it could look like this:
```lua
if ngx.var.request_uri == "/ledge-invalidate/" and ngx.req.get_method() == "POST" then

    local ledgeInvalidation = require "ledge-invalidate.lua"
    ledgeInvalidation:new({
        prefix = "ledge:cache:_1_:_2_:",
        cache_key = {
            [1] = {
                "desktop",
                "tablet",
                "mobile"
            },
            [2] = {
                "open",
                "noaccess",
                "expired",
                "closed"
            }
        }
    })
end
```

It takes two parameters `prefix` and `cache_key`. These are variations of the cache key that ledge uses for different 
ways of caching the site. The data in `cache_key` may differ, it depends on how the cache key is built in your environment.
In the example the actual invalidation files location is `lua/ledge-invalidate/lua.lua`.

You will be able to see if the function is working in the plugin admin interface.

## Filters

####ew_content_container_cache_query
A filter that allows you to define queries used by content containers for the page, the filter is run in context of the 
page. It expects an array of queries (strings) to be returned. 

####ew_cache_invalidator_custom_queries
Add custom queries to be added to the plugin query data, allows users to add any queries for any urls.
Example:
```php
add_filter('ew_cache_invalidator_custom_queries', function($arr) {
    $arr[] = [ 'contenttype:Article AND Example:Value', 'https://www.example.com/example/' ];
    return $arr;
});
```

## Release notes

### 0.1.3
- Fix for OC List notifications where board queries would not be updated.

### 0.1.2
- Added event log view to be able to see what the plugin is invalidating.

### 0.1.1
- Added option to enable/disable event handling.

### 0.1.0
- Initial release.